@echo off
set /a counter=0
REM Get start time:
set STARTTIME=%TIME%
echo Following scripts are being executed.
sqlcmd -S localhost -d master -i Create_DB_ADMINDB.sql 
set /a counter=%counter%+1
echo %counter%. Create_DB_ADMINDB.sql

sqlcmd -S localhost -d master -i Create_Table_BackupConfig.sql 
set /a counter=%counter%+1
echo %counter%. Create_Table_BackupConfig.sql

sqlcmd -S localhost -d master -i Create_Table_Excluded_DB.sql 
set /a counter=%counter%+1
echo %counter%. Create_Table_Excluded_DB.sql

sqlcmd -S localhost -d master -i Create_Table_FragmentationHistory.sql 
set /a counter=%counter%+1
echo %counter%. Create_Table_FragmentationHistory.sql

sqlcmd -S localhost -d master -i dbo_isp_ALTER_INDEX.sql 
set /a counter=%counter%+1
echo %counter%. dbo_isp_ALTER_INDEX.sql

sqlcmd -S localhost -d master -i dbo_USP_SCHED_ALL_BACKUP.sql 
set /a counter=%counter%+1
echo %counter%. dbo_USP_SCHED_ALL_BACKUP.sql

sqlcmd -S localhost -d master -i Insert_Backup_Location.sql 
set /a counter=%counter%+1
echo %counter%. Insert_Backup_Location.sql


REM Get end time:
set ENDTIME=%TIME%
rem Change formatting for the start and end times
    for /F "tokens=1-4 delims=:.," %%a in ("%STARTTIME%") do (
       set /A "start=(((%%a*60)+1%%b %% 100)*60+1%%c %% 100)*100+1%%d %% 100"
    )

    for /F "tokens=1-4 delims=:.," %%a in ("%ENDTIME%") do (
       set /A "end=(((%%a*60)+1%%b %% 100)*60+1%%c %% 100)*100+1%%d %% 100"
    )

    rem Calculate the elapsed time by subtracting values
    set /A elapsed=end-start

    rem Format the results for output
    set /A hh=elapsed/(60*60*100), rest=elapsed%%(60*60*100), mm=rest/(60*100), rest%%=60*100, ss=rest/100, cc=rest%%100
    if %hh% lss 10 set hh=0%hh%
    if %mm% lss 10 set mm=0%mm%
    if %ss% lss 10 set ss=0%ss%
    if %cc% lss 10 set cc=0%cc%

    set DURATION=%hh%:%mm%:%ss%,%cc%
echo.
echo.
echo Start    : %STARTTIME%
echo Finish   : %ENDTIME%
echo.
echo.
echo ---------------------------------------------
echo %counter% scripts executed in: %DURATION% 
echo ---------------------------------------------
