USE [ADMINDB]
GO

/****** Object:  StoredProcedure [dbo].[USP_SCHED_ALL_BACKUP]    Script Date: 10/30/2013 2:44:42 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


CREATE PROCEDURE [dbo].[USP_SCHED_ALL_BACKUP]
	@databaseName sysname, @BackupType nvarchar(4), @bsifull int = 999999999, @lastfulldays int = 7
with encryption
AS
BEGIN
    SET NOCOUNT ON;
    DECLARE @devname nvarchar(256)
    DECLARE @namedigits nvarchar(256)
    DECLARE @sqlcommand nvarchar(4000)
    DECLARE @ParmDefinition nvarchar(500)
    DECLARE @RecoveryMode varchar(128)
    DECLARE @DirLocationPre nvarchar(256)
    DECLARE @DriveFolder nvarchar(255)
    DECLARE @cmd varchar(512)
    DECLARE @result int
	DECLARE @lastlogbackuplsn numeric(25,0) = NULL

    SELECT @DriveFolder = BackupPath + @databaseName + '\', @DirLocationPre = BackupPath + @databaseName + '\' + @databaseName + '_backup_' FROM [dbo].[BackupConfig]

    ---- create backup folder for the databaase ----
    SELECT @cmd = 'dir ' + '"' + @DriveFolder + '"'
    -- Run the dir command, put output of xp_cmdshell into @result
    EXEC @result = master.dbo.xp_cmdshell @cmd, NO_OUTPUT
    if @result <> 0
    BEGIN
         SELECT @cmd = 'mkdir ' + '"' + @DriveFolder + '"'
         EXEC master.dbo.xp_cmdshell @cmd, NO_OUTPUT
         --If @debug = 1 select @cmd
    END


    IF ( UPPER(@BackupType) = 'FULL')
    BEGIN
          SET @sqlcommand = 'SELECT @namedigits = REPLACE(REPLACE(REPLACE(REPLACE(CONVERT(Varchar(60), GETDATE(), 121),''-'',''_''),'':'',''''),''.'',''_''), '' '', ''_'') + ''' 
          SET @sqlcommand = @sqlcommand + '.bak'''
          SET @ParmDefinition = N'@namedigits nvarchar(256) OUTPUT';
          EXEC sp_executesql @sqlcommand, @ParmDefinition, @namedigits = @namedigits out	
          SET @sqlcommand = @DirLocationPre + @namedigits
          SET @sqlcommand = 'SELECT @devname = ''' + @sqlcommand + ''''
          SET @ParmDefinition = N'@databaseName sysname, @DirLocationPre nvarchar(256), @devname nvarchar(256) OUTPUT';
          EXEC sp_executesql @sqlcommand, @ParmDefinition, @databaseName = @databaseName, @DirLocationPre = @DirLocationPre, @devname = @devname out 
          SET @sqlcommand = 'BACKUP DATABASE [' + @databaseName + '] to DISK = ''' + @devname + ''''
          SET @sqlcommand = @sqlcommand + 'WITH INIT, NAME = N''' + @databaseName + '-Full Backup'''
          EXEC(@sqlcommand)
    END
    ELSE
    BEGIN
	    IF ( UPPER(@BackupType) = 'DIFF')
            BEGIN
                  select @bsifull = (select top 1 o.backup_set_id from msdb.dbo.backupset o where o.database_name = @databaseName 
                         and o.type = 'd' and o.backup_start_date > getdate() - @lastfulldays order by o.backup_start_date desc)
                  IF (@bsifull is not null)
                  BEGIN
                         SET @sqlcommand = 'SELECT @namedigits = REPLACE(REPLACE(REPLACE(REPLACE(CONVERT(Varchar(60), GETDATE(), 121),''-'',''_''),'':'',''''),''.'',''_''), '' '', ''_'') + ''' 
                         SET @sqlcommand = @sqlcommand + '.dff'''
                         SET @ParmDefinition = N'@namedigits nvarchar(256) OUTPUT';
                         EXEC sp_executesql @sqlcommand, @ParmDefinition, @namedigits = @namedigits out	
                         SET @sqlcommand = @DirLocationPre + @namedigits
                         SET @sqlcommand = 'SELECT @devname = ''' + @sqlcommand + ''''
                         SET @ParmDefinition = N'@databaseName sysname, @DirLocationPre nvarchar(256), @devname nvarchar(256) OUTPUT';
                         EXEC sp_executesql @sqlcommand, @ParmDefinition, @databaseName = @databaseName, @DirLocationPre = @DirLocationPre, @devname = @devname out
                         SET @sqlcommand = 'BACKUP DATABASE [' + @databaseName + '] to DISK = ''' + @devname + ''''
                         SET @sqlcommand = @sqlcommand + 'WITH DIFFERENTIAL, NOFORMAT, NOINIT,  NAME = N''' + @databaseName + '-Differential Backup'', SKIP, NOREWIND, NOUNLOAD,  STATS = 10'
                         EXEC(@sqlcommand)
                   END
                   ELSE
                   BEGIN
                         SET @sqlcommand = 'SELECT @namedigits = REPLACE(REPLACE(REPLACE(REPLACE(CONVERT(Varchar(60), GETDATE(), 121),''-'',''_''),'':'',''''),''.'',''_''), '' '', ''_'') + ''' 
                         SET @sqlcommand = @sqlcommand + '.bak'''
                         SET @ParmDefinition = N'@namedigits nvarchar(256) OUTPUT';
                         EXEC sp_executesql @sqlcommand, @ParmDefinition, @namedigits = @namedigits out	
                         SET @sqlcommand = @DirLocationPre + @namedigits
                         SET @sqlcommand = 'SELECT @devname = ''' + @sqlcommand + ''''
                         SET @ParmDefinition = N'@databaseName sysname, @DirLocationPre nvarchar(256), @devname nvarchar(256) OUTPUT';
                         EXEC sp_executesql @sqlcommand, @ParmDefinition, @databaseName = @databaseName, @DirLocationPre = @DirLocationPre, @devname = @devname out 
                         SET @sqlcommand = 'BACKUP DATABASE [' + @databaseName + '] to DISK = ''' + @devname + ''''
                         SET @sqlcommand = @sqlcommand + 'WITH INIT, NAME = N''' + @databaseName + '-Full Backup'''
                         EXEC(@sqlcommand)
                   END
            END
            ELSE
            BEGIN
                    SELECT @RecoveryMode = Convert(varchar(128), DATABASEPROPERTYEX([name], 'Recovery')) FROM sys.databases WHERE name = @databaseName
	    	        IF (UPPER(@RecoveryMode) = 'SIMPLE')
                    BEGIN
                          print @databaseName + ' recovery mode is ' + @RecoveryMode 
                          return
                    END
                    ELSE
                    BEGIN
                          IF ( UPPER(@BackupType) = 'TLOG')
                          BEGIN
                                select  @lastlogbackuplsn = ( SELECT last_log_backup_lsn FROM sys.database_recovery_status WHERE database_id = DB_ID(@databaseName))
                                IF (@lastlogbackuplsn is not null)
                                BEGIN
                                    SET @sqlcommand = 'SELECT @namedigits = REPLACE(REPLACE(REPLACE(REPLACE(CONVERT(Varchar(60), GETDATE(), 121),''-'',''_''),'':'',''''),''.'',''_''), '' '', ''_'') + ''' 
                                    SET @sqlcommand = @sqlcommand + '.trn'''
                                    SET @ParmDefinition = N'@namedigits nvarchar(256) OUTPUT';
                                    EXEC sp_executesql @sqlcommand, @ParmDefinition, @namedigits = @namedigits out	
                                    SET @sqlcommand = @DirLocationPre + @namedigits
                                    SET @sqlcommand = 'SELECT @devname = ''' + @sqlcommand + ''''
                                    SET @ParmDefinition = N'@databaseName sysname, @DirLocationPre nvarchar(256), @devname nvarchar(256) OUTPUT';
                                    EXEC sp_executesql @sqlcommand, @ParmDefinition, @databaseName = @databaseName, @DirLocationPre = @DirLocationPre, @devname = @devname out
                                    SET @sqlcommand = 'BACKUP LOG [' + @databaseName + '] to DISK = ''' + @devname + ''''
                                    SET @sqlcommand = @sqlcommand + 'WITH NOFORMAT, NOINIT,  NAME = N''' + @databaseName + '-Transaction Log Backup'', SKIP, NOREWIND, NOUNLOAD,  STATS = 10'
                                    EXEC(@sqlcommand)
                                END
                                ELSE
                                BEGIN
                                    SET @sqlcommand = 'SELECT @namedigits = REPLACE(REPLACE(REPLACE(REPLACE(CONVERT(Varchar(60), GETDATE(), 121),''-'',''_''),'':'',''''),''.'',''_''), '' '', ''_'') + ''' 
                                    SET @sqlcommand = @sqlcommand + '.bak'''
                                    SET @ParmDefinition = N'@namedigits nvarchar(256) OUTPUT';
                                    EXEC sp_executesql @sqlcommand, @ParmDefinition, @namedigits = @namedigits out	
                                    SET @sqlcommand = @DirLocationPre + @namedigits
                                    SET @sqlcommand = 'SELECT @devname = ''' + @sqlcommand + ''''
                                    SET @ParmDefinition = N'@databaseName sysname, @DirLocationPre nvarchar(256), @devname nvarchar(256) OUTPUT';
                                    EXEC sp_executesql @sqlcommand, @ParmDefinition, @databaseName = @databaseName, @DirLocationPre = @DirLocationPre, @devname = @devname out 
                                    SET @sqlcommand = 'BACKUP DATABASE [' + @databaseName + '] to DISK = ''' + @devname + ''''
                                    SET @sqlcommand = @sqlcommand + 'WITH INIT, NAME = N''' + @databaseName + '-Full Backup'''
                                    EXEC(@sqlcommand)
                                END
                          END
                    END
            END
     END
END


GO


