USE [msdb]
GO

/****** Object:  Job [StandardSystemDBFullBackup]    Script Date: 7/24/2013 2:49:12 PM ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0
/****** Object:  JobCategory [[Uncategorized (Local)]]]    Script Date: 7/24/2013 2:49:12 PM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'StandardSystemDBFullBackup', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=2, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=N'sa', 
		@notify_email_operator_name=N'DBAs', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [SysDBFullBackup]    Script Date: 7/24/2013 2:49:12 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'SysDBFullBackup', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'USE  ADMINDB
GO
DECLARE @DBName varchar(128)
DECLARE @NameListLoop int
DECLARE @NameListTableVar table
(UIDNameList int IDENTITY (1,1),
DBName varchar(128)
)
DECLARE @NameListLimit int
----
INSERT INTO @NameListTableVar(DBName)
SELECT name
FROM sys.databases
WHERE 
    name IN (''master'', ''model'', ''msdb'') AND
    name NOT LIKE ''%ReportServer%'' AND
    DATABASEPROPERTYEX([name], ''IsInStandBy'') = 0 AND
    DATABASEPROPERTYEX([name], ''Status'') = ''ONLINE''
    AND is_read_only = 0
    --and databasepropertyex([name], ''recovery'') <> ''simple''
    and databasepropertyex([name], ''updateability'') <> ''read_only''
    and databasepropertyex([name], ''isinstandby'') <> 1
    and databasepropertyex([name], ''status'') <> ''offline''
    and databasepropertyex([name], ''status'') <> ''restoring''
    and databasepropertyex([name], ''status'') <> ''recovery''
    and databasepropertyex([name], ''status'') <> ''suspect''
    AND name not in (SELECT DBName from dbo.Excluded_DB WHERE TypeBackup = ''Excluded'')
    ORDER BY name
----
SELECT @NameListLoop = MIN(UIDNameList) FROM @NameListTableVar
print @NameListLoop
SELECT @NameListLimit = MAX(UIDNameList)+1 FROM @NameListTableVar 
WHILE @NameListLoop < @NameListLimit
BEGIN
----do something as below----
print @NameListLoop
SELECT @DBName = DBName FROM @NameListTableVar WHERE UIDNameList = @NameListLoop
print @DBName
EXEC USP_SCHED_ALL_BACKUP @DBName, ''FULL''
----move to next below
SELECT @NameListLoop = @NameListLoop + 1
END', 
		@database_name=N'ADMINDB', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'NightlySystemFullBackup', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=1, 
		@freq_subday_interval=0, 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=20130306, 
		@active_end_date=99991231, 
		@active_start_time=231500, 
		@active_end_time=235959, 
		@schedule_uid=N'4e6961ce-c96e-4fd6-b800-8c85300a7456'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO


