USE [msdb]
GO

/****** Object:  Job [StandardUpdateStatisticsIndexDefrag]    Script Date: 7/24/2013 2:49:59 PM ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0
/****** Object:  JobCategory [[Uncategorized (Local)]]]    Script Date: 7/24/2013 2:49:59 PM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'StandardUpdateStatisticsIndexDefrag', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=2, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=N'sa', 
		@notify_email_operator_name=N'DBAs', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [UpdateStatistics]    Script Date: 7/24/2013 2:49:59 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'UpdateStatistics', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=3, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'EXEC sp_msForEachdb 
@command1 = ''EXEC ?..sp_updatestats''', 
		@database_name=N'master', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [IndexDefrag]    Script Date: 7/24/2013 2:49:59 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'IndexDefrag', 
		@step_id=2, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=3, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'USE  ADMINDB
GO
SET NOCOUNT ON

DECLARE @dbName varchar(255), @rc int

SELECT name
INTO #db
FROM sys.databases
WHERE 
    name NOT IN (''master'', ''model'', ''msdb'', ''tempdb'') AND
    name NOT LIKE ''%ReportServer%'' AND
    DATABASEPROPERTYEX([name], ''IsInStandBy'') = 0 AND
    DATABASEPROPERTYEX([name], ''Status'') = ''ONLINE''

SELECT @rc = 1, @dbName = MIN(name)
FROM #db

WHILE @rc <> 0
BEGIN
    EXEC  ADMINDB.dbo.isp_ALTER_INDEX 
        @dbName = @dbName,
        @statsMode = ''SAMPLED'',
        @defragType = ''REBUILD'',
        @minFragPercent = 70,
        @maxFragPercent = 100,
        @minRowCount = 1000

    SELECT TOP 1 @dbName = name
    FROM #db
    WHERE name > @dbName
    ORDER BY name

    SET @rc = @@ROWCOUNT
END

DROP TABLE #db

', 
		@database_name=N'master', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [RecordFragmentation]    Script Date: 7/24/2013 2:49:59 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'RecordFragmentation', 
		@step_id=3, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=3, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'
SET NOCOUNT ON

DECLARE @dbName varchar(255), @rc int, @SQLcmd varchar(4000)

SELECT name
INTO #db
FROM sys.databases
WHERE 
    name NOT IN (''master'', ''model'', ''msdb'', ''tempdb'', ''distribution'') AND
    name NOT LIKE ''%ReportServer%'' AND
    DATABASEPROPERTYEX([name], ''IsInStandBy'') = 0 AND
    DATABASEPROPERTYEX([name], ''Status'') = ''ONLINE''

SELECT @rc = 1, @dbName = MIN(name) FROM #db

WHILE @rc <> 0
BEGIN

SET @SQLcmd = 
''INSERT INTO  ADMINDB.dbo.FragmentationHistory
(          [DatabaseName]
           ,[SchemaName]
           ,[TableName]
           ,[IndexName]
           ,[Index_type_desc]
           ,[avg_fragmentation_in_percent]
           ,[avg_fragment_size_in_pages]
           ,[avg_page_space_used_in_percent]
           ,[record_count]
           ,[ghost_record_count]
           ,[fragment_count]
           )
  SELECT CAST(DB_NAME(DATABASE_ID) AS VARCHAR(128)) AS ''''DatabaseName'''', 
  scma.table_schema as ''''Schema'''', scma.table_name,
   SI.name AS [IndexName], 
   IPS.Index_type_desc, 
   IPS.avg_fragmentation_in_percent, 
   IPS.avg_fragment_size_in_pages, 
   IPS.avg_page_space_used_in_percent, 
   IPS.record_count, 
   IPS.ghost_record_count,
   IPS.fragment_count
FROM sys.dm_db_index_physical_stats(db_id(''''''+ @dbName + ''''''), NULL, NULL, NULL , ''''DETAILED'''') IPS
   JOIN ['' + @dbName + ''].sys.sysobjects sobj WITH (nolock) ON IPS.object_id = sobj.id
   JOIN ['' + @dbName + ''].sys.indexes SI WITH (nolock) ON IPS.object_id = SI.object_id 
   JOIN ['' + @dbName + ''].INFORMATION_SCHEMA.TABLES scma on scma.table_name = sobj.name
 WHERE IPS.avg_fragmentation_in_percent > 30 
  AND IPS.record_count > 1000 
  AND IPS.Index_ID > 0 
  AND IPS.index_id = SI.index_id
ORDER BY 1, 4 desc''
exec(''use ['' + @dbName + '']'')
exec('';'')
exec(@SQLcmd)
--print ''---------------------------------------------------------------------------------------------------------------------------------------------------''

    SELECT TOP 1 @dbName = name
    FROM #db
    WHERE name > @dbName
    ORDER BY name

    SET @rc = @@ROWCOUNT
END

DROP TABLE #db


GO', 
		@database_name=N'master', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [CleanupFragmentationHistory]    Script Date: 7/24/2013 2:49:59 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'CleanupFragmentationHistory', 
		@step_id=4, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'delete  from  ADMINDB.dbo.FragmentationHistory where createddatetimestamp < getdate() -90;', 
		@database_name=N'master', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'UpdateStatisticsIndexDefrag', 
		@enabled=1, 
		@freq_type=8, 
		@freq_interval=63, 
		@freq_subday_type=1, 
		@freq_subday_interval=0, 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=1, 
		@active_start_date=20130228, 
		@active_end_date=99991231, 
		@active_start_time=200000, 
		@active_end_time=235959, 
		@schedule_uid=N'8479637c-a57c-4a09-b606-d7562be14f83'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO


