Set-ExecutionPolicy Unrestricted -Scope CurrentUser
function Invoke-Sqlcmd2
{
    param(
    [string]$ServerInstance,
    [string]$Database,
    [string]$Query,
    [Int32]$QueryTimeout=30
    )
 
    $conn=new-object System.Data.SqlClient.SQLConnection
    $conn.ConnectionString="Server={0};Database={1};Integrated Security=True" -f $ServerInstance,$Database
    $conn.Open()
    $cmd=new-object system.Data.SqlClient.SqlCommand($Query,$conn)
    $cmd.CommandTimeout=$QueryTimeout
    $ds=New-Object system.Data.DataSet
    $da=New-Object system.Data.SqlClient.SqlDataAdapter($cmd)
    [void]$da.fill($ds)
    $conn.Close()
    $ds.Tables[0]
 
}
$date = get-date -format yyyyMMdd_HH_mm_ss
$sfile = "G:\SQLPASS-Summit2014\CMS\Scripts\ClearRestore_"+$date +".txt"
$MyResults=@()
$backupquery = @"
SET NOCOUNT ON
DECLARE @databaseName sysname 
CREATE TABLE #TmpCommands 
(ID INT IDENTITY(1,1), 
Cmd VARCHAR(8000) ) 

DECLARE dbnames_cursor CURSOR 
FOR 
 SELECT name  
 FROM master..sysdatabases 
 WHERE name NOT IN ( 'model','tempdb', 'pubs','northwind') 
 --AND (status & 32) =0 -- Do not include restoring 
 AND (status & 64) =0 -- Do not include loading 
 AND (status & 128) =0 -- Do not include recovering 
 AND (status & 256) =0 -- Do not include not recovered 
 AND (status & 512) =0 -- Do not include offline 
 AND (status & 32768) =0 -- Do not include emergency 
 AND (status & 1073741824) =0 -- Do not include cleanly shutdown 
  
 OPEN dbnames_cursor 
  
 FETCH NEXT FROM dbnames_cursor INTO @databaseName 
 WHILE (@@FETCH_STATUS <> -1) 
 BEGIN 
 IF (@@FETCH_STATUS <> -2) 
 BEGIN 

INSERT INTO #TmpCommands(Cmd) 
VALUES ('----------------Script to Restore the ' + @@SERVERNAME + ', ' + @databaseName + ' Database--------------') 

DECLARE @backupStartDate datetime  
DECLARE @backup_set_id_start INT  
DECLARE @backup_set_id_diff INT  
DECLARE @backup_set_id_end INT 

SELECT @backup_set_id_start = MAX(backup_set_id)  
FROM msdb.dbo.backupset  
WHERE database_name = @databaseName AND (type = 'D')

SELECT @backup_set_id_diff = MAX(backup_set_id)  
FROM msdb.dbo.backupset  
WHERE database_name = @databaseName AND (type = 'I') AND backup_set_id > @backup_set_id_start

IF @backup_set_id_diff IS NULL SET @backup_set_id_diff = @backup_set_id_start

SELECT @backup_set_id_end = MIN(backup_set_id)  
FROM msdb.dbo.backupset  
WHERE database_name = @databaseName AND (type = 'D')
AND backup_set_id > @backup_set_id_start 

IF @backup_set_id_end IS NULL SET @backup_set_id_end = 2147483647 

INSERT INTO #TmpCommands(Cmd) 
SELECT Cmd FROM( 
SELECT backup_set_id, 'RESTORE DATABASE ' + @databaseName + ' FROM DISK = '''  
 + mf.physical_device_name + ''' WITH NORECOVERY --' Cmd 
FROM msdb.dbo.backupset b,  
 msdb.dbo.backupmediafamily mf  
WHERE b.media_set_id = mf.media_set_id  
 AND b.database_name = @databaseName  
 AND b.backup_set_id = @backup_set_id_start  
UNION  
SELECT backup_set_id, 'RESTORE DATABASE ' + @databaseName + ' FROM DISK = '''  
 + mf.physical_device_name + ''' WITH NORECOVERY --' Cmd 
FROM msdb.dbo.backupset b,  
 msdb.dbo.backupmediafamily mf  
WHERE b.media_set_id = mf.media_set_id  
 AND b.database_name = @databaseName  
 AND b.backup_set_id = @backup_set_id_diff  
UNION  
SELECT backup_set_id, 'RESTORE LOG ' + @databaseName + ' FROM DISK = '''  
 + mf.physical_device_name + ''' WITH FILE = ' + CAST(position AS VARCHAR(10)) + ', NORECOVERY,  NOUNLOAD,  STATS = 10 ;--' Cmd 
FROM msdb.dbo.backupset b,  
 msdb.dbo.backupmediafamily mf  
WHERE b.media_set_id = mf.media_set_id  
 AND b.database_name = @databaseName  
 AND b.backup_set_id >= @backup_set_id_diff AND b.backup_set_id < @backup_set_id_end  
 AND b.type = 'L'  
UNION  
SELECT 2147483647 AS backup_set_id, 'RESTORE DATABASE ' + @databaseName + ' WITH RECOVERY --' Cmd 
) A 
-- ORDER BY backup_set_id 


END 

FETCH NEXT FROM dbnames_cursor INTO @databaseName  
 END 

CLOSE dbnames_cursor 
 DEALLOCATE dbnames_cursor 

DECLARE @PrintCommand VARCHAR(8000) 

 SELECT Cmd FROM #TmpCommands ORDER BY ID 

DROP TABLE #TmpCommands   
"@
#$query = @"
#SELECT DISTINCT
#        s.server_name
#FROM    msdb.dbo.sysmanagement_shared_registered_servers s
#        JOIN msdb.dbo.sysmanagement_shared_server_groups g ON s.server_group_id = g.server_group_id
#WHERE   g.name = 'PRODUCTION SERVERS'
#"@
#$serverInstances = invoke-sqlcmd  -ServerInstance HOUCMS -Database msdb -Query $query
try
{
#foreach ($server in $serverInstances)
foreach ($server in (Get-Content G:\SQLPASS-Summit2014\DBANotification\myservers.txt))
{  
# $MyResults += invoke-sqlcmd -ServerInstance $server.server_name -Database msdb -Query $backupquery
  write-host $server
  $MyResults += Invoke-Sqlcmd2 $server master $backupquery 60
 } 
 $MyResults  | Where-Object {$_} | Out-File G:\SQLPASS-Summit2014\CMS\Scripts\ClearRestore.txt -width 1000
 Copy-Item G:\SQLPASS-Summit2014\CMS\Scripts\ClearRestore.txt $sfile
}
catch
{
        write-host "Caught an exception:" -ForegroundColor Red
        write-host "Exception Type: $($_.Exception.GetType().FullName)" -ForegroundColor Red
        write-host "Exception Message: $($_.Exception.Message)" -ForegroundColor Red
        write-host $server.server_name -ForegroundColor Red
}
finally
{
        write-host "CleanRestore auto-generation finally completed."
}
exit
