Set-ExecutionPolicy Unrestricted -Scope CurrentUser
function Invoke-Sqlcmd2
{
    param(
    [string]$ServerInstance,
    [string]$Database,
    [string]$Query,
    [Int32]$QueryTimeout=30
    )
 
    $conn=new-object System.Data.SqlClient.SQLConnection
    $conn.ConnectionString="Server={0};Database={1};Integrated Security=True" -f $ServerInstance,$Database
    $conn.Open()
    $cmd=new-object system.Data.SqlClient.SqlCommand($Query,$conn)
    $cmd.CommandTimeout=$QueryTimeout
    $ds=New-Object system.Data.DataSet
    $da=New-Object system.Data.SqlClient.SqlDataAdapter($cmd)
    [void]$da.fill($ds)
    $conn.Close()
    $ds.Tables[0]
 
}
$Style = "<style>"
$Style = $Style + "BODY{background-color:peachpuff;}"
$Style = $Style + "TABLE{border-width: 1px;border-style: solid;border-color: black;border-collapse: collapse;}"
$Style = $Style + "TH{border-width: 1px;padding: 0px;border-style: solid;border-color: black;}"
$Style = $Style + "TD{border-width: 1px;padding: 0px;border-style: solid;border-color: black;}"
$Style = $Style + "</style>"
$MyResults=@()
$backupquery = @"
SELECT  @@ServerName AS [HostName], 
CASE
WHEN CHARINDEX('\', @@ServerName) = 0 THEN 'MSSQLSERVER'
WHEN CHARINDEX('\', @@ServerName) <> 0 THEN SUBSTRING(@@ServerName, CHARINDEX('\', @@ServerName)+1, LEN(@@ServerName))
END
AS [InstanceName],
   msdb.dbo.backupset.database_name AS [DatabaseName],  
   '#' + CONVERT(varchar(100), msdb.dbo.backupset.backup_start_date, 101) + ' ' +  CONVERT(varchar(100), msdb.dbo.backupset.backup_start_date, 108) + '#' AS [StartTime],  
   '#' + CONVERT(varchar(100), msdb.dbo.backupset.backup_finish_date, 101) + ' ' +  CONVERT(varchar(100), msdb.dbo.backupset.backup_finish_date, 108) + '#' AS [EndTime],  
   'success' AS [Status],
   msdb.dbo.backupset.backup_size/1014/1014 AS [SizeOfBackup],
   CASE msdb..backupset.type  
       WHEN 'D' THEN 'Full'  
	   WHEN 'I' THEN '1'  
       WHEN 'L' THEN 'Incr'  
   END AS [Level],
   '#' + CONVERT(varchar(100), msdb.dbo.backupset.backup_start_date, 101) + ' ' +  CONVERT(varchar(100), msdb.dbo.backupset.backup_start_date, 108) + '#' AS [QueueTime],
  'SQL_SERVER' AS [GroupName]
FROM   msdb.dbo.backupmediafamily  
   INNER JOIN msdb.dbo.backupset ON msdb.dbo.backupmediafamily.media_set_id = msdb.dbo.backupset.media_set_id  
WHERE  (CONVERT(datetime, msdb.dbo.backupset.backup_start_date, 101) > GETDATE() - 1)  
"@
try
{
foreach ($server in (Get-Content G:\SQLPASS-Summit2014\DBANotification\myservers.txt))
{   write-host $server
  $MyResults += invoke-sqlcmd2 $server msdb $backupquery 60 } 
 $MyResults | Where-Object {$_} | Export-Csv G:\SQLPASS-Summit2014\DBANotification\Successbackup.csv -NoTypeInformation
(Get-Content  G:\SQLPASS-Summit2014\DBANotification\Successbackup.csv) | % {$_ -replace '"', ""} | % {$_ -replace '#', '"'} | out-file -FilePath G:\SQLPASS-Summit2014\DBANotification\UnquotedSuccessbackup.csv
import-csv G:\SQLPASS-Summit2014\DBANotification\UnquotedSuccessbackup.csv | ConvertTo-Html -Head $Style | Out-File G:\SQLPASS-Summit2014\DBANotification\Successbackup.html
}
catch
{
        write-host $server
        write-host "Caught an exception:" -ForegroundColor Red
        write-host "Exception Type: $($_.Exception.GetType().FullName)" -ForegroundColor Red
        write-host "Exception Message: $($_.Exception.Message)" -ForegroundColor Red
        write-host $server.server_name -ForegroundColor Red
}
finally
{
$fromaddress = "sqlsat308@earthlink.net" 
$toaddress = "sqlsat308@earthlink.net" 
$bccaddress = "sqlsat308@earthlink.net" 
$CCaddress = "sqlsat308@earthlink.net" 
$Subject = "SQL Server Success Backup Database Last One Day" 
$body = get-content G:\SQLPASS-Summit2014\DBANotification\Successbackup.html
##$attachment = "G:\SQLPASS-Summit2014\DBANotification\messageProd.csv" 
$smtpserver = "smtpauth.earthlink.net" 
$SMTPPort = "587"
$Username = "sqlsat308@earthlink.net"
$Password = "AutoDBA2014"
$message = new-object System.Net.Mail.MailMessage 
$message.From = $fromaddress 
$message.To.Add($toaddress) 
$message.CC.Add($CCaddress) 
$message.Bcc.Add($bccaddress) 
$message.IsBodyHtml = $True 
$message.Subject = $Subject 
##$attach = new-object Net.Mail.Attachment($attachment) 
##$message.Attachments.Add($attach) 
$message.body = $body 
$smtp = new-object Net.Mail.SmtpClient($smtpserver, $SMTPPort) 
$smtp.Credentials = New-Object System.Net.NetworkCredential($Username, $Password);
$smtp.Send($message)
        write-host "Finally Query Success Backup Last One Day completed."
}
exit


